﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

namespace Bonfire
{
    public class HPBar : MonoBehaviour
    {
        RectTransform foreground = null;
        PlayerStatus status = null;

        void Start()
        {
            // 親 に付いている PlayerStatus を取得する
            status = transform.parent.GetComponent<PlayerStatus>();

            // ForegroundImage を探す
            foreach (RectTransform child in GetComponentsInChildren<RectTransform>() )
            {
                if (child.name == "ForegroundImage")
                {
                    foreground = child;
                }
            }

        }

        void Update()
        {
            float hpPercentage = (float)status.HP / (float)status.MaxHP;

            // ForegroundImage の画像をfillAmountで左から削り、localPositionで左に寄せる
            Image fg = foreground.GetComponent<Image>();
            fg.fillAmount = hpPercentage;
            foreground.localPosition = new Vector3(-100 + 100 * hpPercentage, 0, 0);

            // 常にカメラの方を向ける
            transform.forward = Camera.main.transform.forward;
        }
    }

}
