﻿using UnityEngine;

namespace Bonfire
{
    public class IKControl : MonoBehaviour
    {
        public Transform leftHandObj = null;

        Animator animator;
        internal bool isIKActive = true;

        void Start()
        {
            animator = GetComponent<Animator>();
        }

        // IK を計算するためのコールバック
        void OnAnimatorIK()
        {
            if (animator)
            {
                if(isIKActive){
                    if (leftHandObj != null)
                    {
                        // 指定されている場合は、左手のターゲット位置と回転を設定する
                        animator.SetIKPositionWeight(AvatarIKGoal.LeftHand, 1);
                        animator.SetIKRotationWeight(AvatarIKGoal.LeftHand, 1);
                        animator.SetIKPosition(AvatarIKGoal.LeftHand, leftHandObj.position);
                        animator.SetIKRotation(AvatarIKGoal.LeftHand, leftHandObj.rotation);
                    }

                }
                else
                {
                    //IK が有効でなければ、手の位置と回転を元の位置に戻す
                    animator.SetIKPositionWeight(AvatarIKGoal.LeftHand, 0);
                    animator.SetIKRotationWeight(AvatarIKGoal.LeftHand, 0);
                }
            }
        }
    }

}